<?php
/*
Plugin Name: Dispito
Plugin URI: http://www.dispito.com/
Description: The Dispito replaces your WordPress comment system with your comments hosted and powered by Dispito.
Author: Network image
Version: 1.0.1
Author URI: http://www.ni.cz
*/

define('DISPITO_ADMIN_REG_URL', 'http://partner.appni.net/website/reg');
define('DISPITO_ADMIN_WEBSITE_INFO_URL', 'http://partner.appni.net/json/website-info');
define('DISPITO_DB_TABLE', 'dispito_info');

//require(ABSPATH . WPINC .'/ms-functions.php');

// get table name, private function
function _dispitoTable()
{
        global $wpdb;
        return $wpdb->prefix . DISPITO_DB_TABLE;
}

// get current language, private function
function _dispitoGetLang()
{
	$blogLang = get_bloginfo('language');

	if (strpos($blogLang, '-') !== false) {
		$langInfo = explode('-', $blogLang);
		return $langInfo[0];
	}
	return $blogLang;
}

// init plugin
function dispitoInitPlugin()
{
	add_action("admin_menu", "dispitoAddPage");
}

// add page to admin submenu 'comments'
function dispitoAddPage()
{
	add_submenu_page(
        	'edit-comments.php',
		'Dispito',
        	'Dispito',
        	'moderate_comments',
        	'dispito',
        	'dispitoManage'
     	);
}

function dispitoDBWebsite()
{
        global $wpdb;
	$query = "SELECT website FROM " . _dispitoTable();
        return $wpdb->get_var($query, 0, 0);	
}

// admin page
function dispitoManage()
{
	global $wpdb;

	// info from general wp setting
	$blogName	= get_bloginfo('name');
	$blogUrl	= get_bloginfo('url');

	$website = dispitoDBWebsite();
	if ( !$website ) {
		$curl = curl_init( DISPITO_ADMIN_WEBSITE_INFO_URL . '?hostname=' . urlencode($blogUrl) );
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 5);
		$websiteInfo = json_decode( curl_exec($curl) );
		curl_close($curl);

		if ($websiteInfo && $websiteInfo->statusCode == 'OK') {
			$table = _dispitoTable();
			$wpdb->query("INSERT INTO $table (website) values ('" . $websiteInfo->data->nickname . "')");
		}
	}

	$urlPar = "?source=wordpress&hostname=" . urlencode($blogUrl) . "&website_name=" . $blogName;

	$urlPar = $urlPar . '&lang=' . _dispitoGetLang();

	echo "<iframe src='" . DISPITO_ADMIN_REG_URL . $urlPar . "' frameborder='0' style='width: 100%; height: 100%; min-height: 800px;'></iframe>";
}

// replace comments template 
function dispitoCommentsTemplate()
{
	return dirname(__FILE__) . '/comments.php';
}

// add javascript for generate discussion
function dispitoAddDispitoEmbedScript()
{
	$website = dispitoDBWebsite();

        wp_register_script('dispito_embed', 'http://disc.appni.net/embed.js?divId=dispito_thread&website=' . $website);
        wp_enqueue_script('dispito_embed');    
}

// add meta tag for lanfuage and description, required for generate disc
function dispitoAddMetaTag()
{
	if ( is_single() ) {
		$desc = single_post_title('', false); 
    	} else {
        	$desc = get_bloginfo('name') . ' - ' . get_bloginfo('description');
	}

	echo '<meta name="description" content="'.$desc.'">';
	echo '<meta http-equiv="content-language" content="' . _dispitoGetLang() . '">';
}

// install dispito plugin
function dispitoInstall()
{
	global $wpdb;
        $table = _dispitoTable();
        $dbOk = ( 1 === $wpdb->query( 'SHOW TABLES like "' . $table . '";' ) );

        if ( !$db_ok )  {
                $wpdb->query( "DROP TABLE $table;" );

                // install database
                $sql = "CREATE TABLE $table (website VARCHAR(255) NOT NULL);";
                $wpdb->query( $sql );
        }
}

// uninstall dispito plugin
function dispitoUninstall()
{
	global $wpdb;
        $wpdb->query( 'DROP TABLE ' . _dispitoTable() );
}

register_activation_hook(__FILE__, 'dispitoInstall');

register_uninstall_hook(__FILE__, 'dispitoUninstall');

if ( is_admin() ) {
	// init admin part from Dispito plugin
	dispitoInitPlugin();
}
else {
	add_action('wp_head', 'dispitoAddMetaTag');

	add_action('wp_enqueue_scripts', 'dispitoAddDispitoEmbedScript');

	add_filter('comments_template', 'dispitoCommentsTemplate');
}
?>
